/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.components;

import event.events.ToggleEvent;
import event.EventData;
import logging.Logger;
import main.GameApp;

/**
 *
 * @author nico3000
 */
public class ToggleButton extends Component {
    private String text;
    private boolean focused = false;
    private boolean hovered = false;
    private boolean activated = false;
    private boolean buttonDown = false;

    public ToggleButton(String text) {
        this.text = text;
    }

    public void setText(String text) {
        this.text = text;
    }
    
    @Override
    protected void repaint() {
        if(this.text.startsWith("res:")) {
            this.setTexture(this.getGui().getDrawer().createImageButton(this.text.substring(4), this.getWidth(), this.getHeight(), this.focused, this.hovered, this.activated || (this.buttonDown && this.hovered)));
        } else {
            this.setTexture(this.getGui().getDrawer().createButton(this.text, this.getWidth(), this.getHeight(), this.focused, this.hovered, this.activated || (this.buttonDown && this.hovered)));
        }
    }

    @Override
    public boolean onCursorEntered(int x, int y) {
        this.hovered = true;
        this.repaint();
        return true;
    }

    @Override
    public void onCursorLeft() {
        this.hovered = false;
        this.repaint();
    }

    @Override
    public void onCursorMoved(int posX, int posY, int dx, int dy) {
        // nothing to do
    }

    @Override
    public boolean onFocusGained() {
        this.focused = true;
        this.repaint();
        return true;
    }

    @Override
    public void onFocusLost() {
        this.focused = false;
        this.repaint();
    }

    @Override
    public boolean onButtonDown(int button, int x, int y) {
        this.buttonDown = true;
        this.repaint();
        return true;
    }

    @Override
    public boolean onButtonUp(int button, int x, int y, boolean clicked) {
        if(button == 0) {
            if(this.hovered) {
                this.activated = !this.activated;
                this.fireAction(this.activated);
            }
            this.buttonDown = false;
            this.repaint();
        }
        return true;
    }

    @Override
    public boolean onDragged(int button, int x, int y, int dx, int dy) {
        return false;
    }

    @Override
    public void onUpdate(long deltaMillis) {
        // nothing to do
    }

    @Override
    public boolean onKeyDown(int key, char c) {
        return false;
    }

    @Override
    public boolean onKeyUp(int key) {
        return false;
    }
    
}
