/*
 * This software is the proprietary information of nico3000.
 */
package main;

import logging.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import util.XMLUtil;

/**
 *
 * @author nico3000
 */
public class ExampleGameLogic extends BaseGameLogic {

    @Override
    public void loadLevel(String resource) {
        Document doc = GameApp.loadXML(resource);
        Node node = XMLUtil.getChildByType(doc, "Scene");
        if(node != null) {
            node = node.getFirstChild();
        }
        while(node != null) {
            switch(node.getNodeName()) {
                case "Actor":
                    this.createActor(node);
                    break;
                case "#comment":
                case "#text":
                    // nothing to do
                    break;
                default:
                    Logger.INSTANCE.warning("node " + node.getNodeName() + " was ignored in " + resource);
                    break;
            }
            node = node.getNextSibling();
        }
    }
    
    /**
     * Erzeugt einen Actor aus einer Node einer xml-Leveldatei.
     * @param node Die Node des Actors
     */
    private void createActor(Node node) {
        String resource = XMLUtil.getAttributeAsString(node, "resource");
        if(resource != null) {
            this.createActor(resource, node);
        }
    }    
}
