/*
 * Copyright (C) 2013 nico3000 - All Rights Reserved
 */
package resource.loader;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.IOException;
import logging.Logger;
import resource.ResHandle;

/**
 *
 * @author nico3000
 */
public class DstImageLoader implements ResourceLoader {
    private ImageExtraData data = null;

    @Override
    public String getPattern() {
        return "(.*)(.dst)";
    }

    @Override
    public boolean useRawFile() {
        return false;
    }

    @Override
    public int getLoadedResourceSize(byte[] buffer, int rawSize) {
        DataInputStream dis = new DataInputStream(new ByteArrayInputStream(buffer));
        int width = 0, height = 0;
        try {
            width = dis.readInt();
            height = dis.readInt();
        } catch (IOException ex) {
            Logger.INSTANCE.error(ex.getMessage());
        } finally {
            try {
                dis.close();
            } catch (IOException ex) {
                Logger.INSTANCE.error(ex.getMessage());
            }
        }
        this.data = new ImageExtraData(width, height, 1);
        return 4 * width * height;
    }

    @Override
    public boolean loadResource(byte[] buffer, int rawSize, ResHandle handle) {
        System.arraycopy(buffer, 8, handle.getWritableBuffer(), 0, buffer.length - 8);
        handle.setExtra(this.data);
        return true;
    }
    
}
